<?php

function comment_admin_notify_settings($form, &$form_state) {
  $form['comment'] = array(
    '#type' => 'fieldset',
    '#title' => t('Comment notification'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['comment']['comment_admin_notify'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable'),
    '#default_value' => variable_get('comment_admin_notify', TRUE),
  );
  $form['comment']['comment_admin_notify_mailto'] = array(
    '#type' => 'textfield',
    '#title' => t('E-mail to address'),
    '#default_value' => variable_get('comment_admin_notify_mailto', variable_get('site_mail')),
  );
  $form['comment']['comment_admin_notify_subject'] = array(
    '#type' => 'textfield',
    '#title' => t('E-mail subject'),
    '#default_value' => variable_get('comment_admin_notify_subject', 'Comment notification'),
  );
  $form['comment']['comment_admin_notify_mailtext'] = array(
    '#type' => 'textarea',
    '#title' => t('E-mail content'),
    '#default_value' => variable_get('comment_admin_notify_mailtext', comment_admin_default_mailtext()),
    '#return_value' => 1,
    '#cols' => 60,
    '#rows' => 12,
    '#token_types' => array('comment'),
    '#element_validate' => array('token_element_validate'),
  );
  $form['comment']['token_help'] = array(
    '#theme' => 'token_tree',
    '#token_types' => array('comment'),
  );

  $form['#validate'][] = 'comment_admin_notify_settings_validate';

  return system_settings_form($form);
}

/**
 * Validates the submitted comment_admin_notify_settings form.
 */
function comment_admin_notify_settings_validate($form, &$form_state) {
  // Validate the e-mail address.
  if ($error = user_validate_mail($form_state['values']['comment_admin_notify_mailto'])) {
    form_set_error('comment_admin_notify_mailto', $error);
  }
}
